=== src/config/CMakeLists.txt ===
target_sources(
  flameshot
  PRIVATE buttonlistview.cpp
          clickablelabel.cpp
          configwindow.cpp
          extendedslider.cpp
          filenameeditor.cpp
          generalconf.cpp
          strftimechooserwidget.cpp
          styleoverride.cpp
          uicoloreditor.cpp
          visualseditor.cpp
          shortcutswidget.cpp
          setshortcutwidget.cpp
)
