=== src/widgets/panel/CMakeLists.txt ===
# Required to generate MOC
target_sources(flameshot PRIVATE sidepanelwidget.h utilitypanel.h)

target_sources(flameshot PRIVATE sidepanelwidget.cpp utilitypanel.cpp)
