=== debian/changelog ===
flameshot (0.9.0+ds1-2+deb11u2) bullseye; urgency=medium

  * debian/NEWS: Renamed from debian/NEWS.Debian for proper
    installation.

 -- Boyuan Yang <byang@debian.org>  Sun, 24 Sep 2023 19:01:31 -0400

flameshot (0.9.0+ds1-2+deb11u1) bullseye; urgency=medium

  * debian/patches/0006-Disable-default-imgur-token.patch:
    Disable default imgur uploading token.
    .
    Flameshot before v0.10.0 does not pop up confirmation before
    uploading the screenshot to imgur, which is a security risk
    that may leak sensitive user information.
    .
    This patch strips the embedded default imgur token from the
    source code to disable default image uploading. Users who need
    image uploading functionality may set their own imgur token
    in flameshot configuration to re-enable this functionality.    
    (Closes: #1051408)

 -- Boyuan Yang <byang@debian.org>  Thu, 21 Sep 2023 13:16:48 -0400

flameshot (0.9.0+ds1-2) unstable; urgency=high

  * debian/patches/0003-Disable-automatic-update-checking-by-default.patch:
    Disable new version checking by default on new installation.
    Users may re-enable this feature at any time in the config menu.
    (Closes: #991392)
  * debian/patches/0004-Fix-nullptr-reference-when-trayicon-is-disabled.patch:
    Fix a crash when flameshot is set to disable tray icon and also
    enable new version checking. (Closes: #991320)
  * debian/patches/9af391b2e94b2ba21cb6af32535ed38240f695c0.patch:
    Add upstream workaround for Xfce's incorrect icon handling.
    (Closes: #991216)

 -- Boyuan Yang <byang@debian.org>  Thu, 22 Jul 2021 18:10:19 -0400
